// This class was created by JaTiTV.

package net.t2code.autoresponse.Spigot.config.languages;

import lombok.NonNull;
import net.t2code.autoresponse.Spigot.Main;
import net.t2code.autoresponse.Util;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_LanguageWriter;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import net.t2code.t2codelib.SPIGOT.system.config.languages.T2CLibLanguages;
import net.t2code.t2codelib.util.T2C_ConfigItemLanguages;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.HashMap;
import java.util.List;

public class Languages {
    public enum VALUES implements T2C_ConfigItemLanguages {
        otherLang("plugin", null, new HashMap<>() {{
            put(T2C_LanguageEnum.german, null);
            put(T2C_LanguageEnum.english, null);
        }}, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of("Wenn du eine Eigene Sprache hinzufügen magst, dann kopiere einfach eine Sprachdatei und benenne sie in deine Sprache, dies kannst du dann in der config.yml einstellen.", ""));
            put(T2C_LanguageEnum.english, List.of("If you want to add your own language, simply copy a language file and rename it to your language, you can then set this in config.yml.", ""));
        }}),
        reloadStart("plugin.reload.start", null, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of("[prefix] &6Plugin wird neu geladen..."));
            put(T2C_LanguageEnum.english, List.of("[prefix] &6Plugin is reloaded..."));
        }}, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        reloadEnd("plugin.reload.end", null, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of("[prefix] &2Plugin wurde erfolgreich neu geladen."));
            put(T2C_LanguageEnum.english, List.of("[prefix] &2Plugin was successfully reloaded."));
        }}, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        noPermissionForCommand("plugin.forCommand", null, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of("[prefix] &cF[ue]r &b[cmd] &cfehlt dir die Permission &6[perm]&c!"));
            put(T2C_LanguageEnum.english, List.of("[prefix] &cFor &b[cmd] &cyou lack the permission &6[perm]&c!"));
        }}, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        ;
        private final String path;
        private Object value;
        private final HashMap<T2C_LanguageEnum, List<String>> lang;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, @NonNull HashMap<T2C_LanguageEnum, List<String>> lang, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.lang = lang;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            if (value == null) {
                return lang.get(T2C_LanguageEnum.english);
            } else return value;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getLanguage() {
            return lang;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean isReload) {
        convert(isReload);
        T2C_LanguageWriter.createConfig(Util.getPrefix(), Main.getPath(), T2CLibLanguages.VALUES.values(), T2C_LibConfig.VALUES.language.getValue().toString(), isReload, Util.getConfigLogo());
    }

    private static void convert(boolean isReload) {
        File f = new File(Main.getPath() + "/languages/");
        File[] fileArray = f.listFiles();
        if (fileArray == null) return;

        for (File file : fileArray) {
            String sub = file.getName().substring(file.getName().length() - 4);
            if (sub.equals(".yml")) {
                if (file.getName().contains("_messages")) {
                    File nf = new File(file.getName().replace("_messages", ""));
                    if (file.renameTo(nf)) {
                        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(nf);
                        VALUES.reloadStart.setValue(yamlConfiguration.getString("Plugin.Reload.Start"));
                        VALUES.reloadEnd.setValue(yamlConfiguration.getString("Plugin.Reload.End"));
                        VALUES.noPermissionForCommand.setValue(yamlConfiguration.getString("Plugin.ForCommand"));
                    }
                }
            }
        }
    }
}
