// This class was created by JaTiTV.

package net.t2code.autoresponse.Spigot.config.response;

import net.t2code.autoresponse.Spigot.Main;
import net.t2code.autoresponse.Spigot.config.config.Config;
import net.t2code.autoresponse.Spigot.objects.ResponsesObject;
import net.t2code.autoresponse.Util;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;

public class ResponseFile {
    public enum VALUES implements T2C_ConfigItem {
        enable("response.enable", true, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of("In dieser Option kannst du die Sprache des Plugins einstellen."));
            put(T2C_LanguageEnum.english, List.of("In this option you can set the language of the plugin."));
        }}),
        responseKeys("response.responseKeys", List.of(".example"), true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        contains("response.contains", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        blockKeyMessage("response.blockKeyMessage", true, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        permNecessary("response.permission.necessary", true, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        permission("response.permission.permission", "t2c-autoresponse.response.example", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        delayInTicks("response.response.delayInTicks", 0, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        delayAsync("response.response.async", true, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        commandEnable("response.command.enable", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        commandAsConsole("response.command.commandAsConsole", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        bungeeCommand("response.command.proxyCommand", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        command("response.command.commands", List.of("say hi"), true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        messageEnable("response.message.enable", true, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        messageGlobalServer("response.message.global.enable", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        messageGlobalProxy("response.message.global.proxy", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        messages("response.message.messages", List.of("[prefix] <dark_green>This is an Automated response from <dark_gray>[<dark_red>T2Code</dark_red><gray>-</gray><aqua>AutoResponse</aqua>]</dark_gray>.</dark_green>", "[prefix] <gold>Contact us for questions / support on our <dark_purple><hover:show_text:'<dark_purple>Discord:</dark_purple> <yellow>dc.t2code.net</yellow>'><click:open_url:'http://dc.t2code.net'>Discord</click></hover></dark_purple>.</gold>"), true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        protectionGameModeEnable("response.protection.gameMode.enable", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        protectionGameModeMode("response.protection.gameMode.mode", "blacklist", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        protectionGameModeList("response.protection.gameMode.list", List.of("CREATIVE", "SPECTATOR"), true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        protectionWorldEnable("response.protection.world.enable", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        protectionWorldMode("response.protection.world.mode", "blacklist", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        protectionWorldList("response.protection.world.list", List.of("World1", "World2"), true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),


        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return Config.VALUES.language.getValue().toString();
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }


    public static void set(boolean isReload) {
        File of = new File(Main.getPath() + "/Responses/");
        if (of.exists()){
           convert(isReload);
        }

        Main.allResponses.clear();
        Main.allResponse.clear();
        File f = new File(Main.getPath() + "/responses/");
        File[] fileArray = f.listFiles();
            if (fileArray == null) {
            T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "/responses/responseExample.yml"), VALUES.values(), isReload, Util.getConfigLogo());
        }

        for (File file : fileArray) {
            String sub = file.getName().substring(file.getName().length() - 4);
            if (sub.equals(".yml")) {
                T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "/responses/" + file.getName()), VALUES.values(), isReload, Util.getConfigLogo());
                ResponsesObject response = new ResponsesObject(
                        (boolean) VALUES.enable.value,
                        (List<String>) VALUES.responseKeys.value,
                        (boolean) VALUES.contains.value,
                        (boolean) VALUES.blockKeyMessage.value,
                        (boolean) VALUES.permNecessary.value,
                        VALUES.permission.value.toString(),
                        (int) VALUES.delayInTicks.value,
                        (boolean) VALUES.delayAsync.value,
                        (boolean) VALUES.commandEnable.value,
                        (boolean) VALUES.commandAsConsole.value,
                        (boolean) VALUES.bungeeCommand.value,
                        (List<String>) VALUES.command.value,
                        (boolean) VALUES.messageEnable.value,
                        (boolean) VALUES.messageGlobalServer.value,
                        (boolean) VALUES.messageGlobalProxy.value,
                        (List<String>) VALUES.messages.value,
                        (boolean) VALUES.protectionGameModeEnable.value,
                        VALUES.protectionGameModeMode.value.toString(),
                        (List<String>) VALUES.protectionGameModeList.value,
                        (boolean) VALUES.protectionWorldEnable.value,
                        VALUES.protectionWorldMode.value.toString(),
                        (List<String>) VALUES.protectionWorldList.value
                );
                Main.allResponses.add(response);
                Main.allResponse.addAll((List<String>) VALUES.responseKeys.value);
            }
        }
    }

    public static void convert(boolean isReload) {
        File x = new File(Main.getPath() + "/Responses/");
        x.renameTo(new File(Main.getPath() + "/oldResponses/"));

        File f = new File(Main.getPath() + "/oldResponses/");
        File[] fileArray = f.listFiles();
        if (fileArray == null) return;
        for (File file : fileArray) {
            String sub = file.getName().substring(file.getName().length() - 4);
            if (sub.equals(".yml")) {
                YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(file);

                ResponseFile.VALUES.enable.setValue(yamlConfiguration.getBoolean("Response.Enable"));
                ResponseFile.VALUES.responseKeys.setValue(yamlConfiguration.getStringList("Response.ResponseKeys"));
                ResponseFile.VALUES.contains.setValue(yamlConfiguration.getBoolean("Response.Contains"));

                ResponseFile.VALUES.blockKeyMessage.setValue(yamlConfiguration.getBoolean("Response.BlockKeyMessage"));
                ResponseFile.VALUES.permNecessary.setValue(yamlConfiguration.getBoolean("Response.Permission.Necessary"));
                ResponseFile.VALUES.permission.setValue(yamlConfiguration.getString("Response.Permission.Permission"));

                ResponseFile.VALUES.delayInTicks.setValue(yamlConfiguration.getInt("Response.Response.DelayInTicks"));
                ResponseFile.VALUES.delayAsync.setValue(yamlConfiguration.getBoolean("Response.Response.Async"));

                ResponseFile.VALUES.commandEnable.setValue(yamlConfiguration.getBoolean("Response.Command.Enable"));
                ResponseFile.VALUES.commandAsConsole.setValue(yamlConfiguration.getBoolean("Response.Command.CommandAsConsole"));
                ResponseFile.VALUES.bungeeCommand.setValue(yamlConfiguration.getBoolean("Response.Command.BungeeCommand"));
                ResponseFile.VALUES.command.setValue(yamlConfiguration.getStringList("Response.Command.Commands"));

                ResponseFile.VALUES.messageEnable.setValue(yamlConfiguration.getBoolean("Response.Message.Enable"));
                ResponseFile.VALUES.messageGlobalServer.setValue(yamlConfiguration.getBoolean("Response.Message.Global.Enable"));
                ResponseFile.VALUES.messageGlobalProxy.setValue(yamlConfiguration.getBoolean("Response.Message.Global.Bungee"));
                ResponseFile.VALUES.messages.setValue(yamlConfiguration.getStringList("Response.Message.Messages"));

                ResponseFile.VALUES.protectionGameModeEnable.setValue(yamlConfiguration.getBoolean("Response.Protection.GameMode.Enable"));
                ResponseFile.VALUES.protectionGameModeMode.setValue(yamlConfiguration.getString("Response.Protection.GameMode.Mode"));
                ResponseFile.VALUES.protectionGameModeList.setValue(yamlConfiguration.getStringList("Response.Protection.GameMode.List"));
                ResponseFile.VALUES.protectionWorldEnable.setValue(yamlConfiguration.getBoolean("Response.Protection.World.Enable"));
                ResponseFile.VALUES.protectionWorldMode.setValue(yamlConfiguration.getString("Response.Protection.World.Mode"));
                ResponseFile.VALUES.protectionWorldList.setValue(yamlConfiguration.getStringList("Response.Protection.World.List"));
                T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "/responses/" + file.getName()), VALUES.values(), isReload, Util.getConfigLogo());

            }
        }
        File[] fileArray2 = f.listFiles();
        if (fileArray2 == null) return;
        Path directory = Paths.get(Main.getPath() + "/oldResponses/");
        try {
            Files.walk(directory)
                    .sorted(Comparator.reverseOrder())
                    .forEach(path -> {
                        try {
                            Files.delete(path);
                        } catch (IOException e) {
                            System.err.println("Error when deleting " + path + ": " + e.getMessage());
                        }
                    });
        } catch (IOException e) {
            System.err.println("Error when going through the directory: " + e.getMessage());
        }
    }
}
